using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ColorSpace
{
	/// <summary>
	/// Summary description for ColorPenForm.
	/// </summary>
	public class ColorPenForm : System.Windows.Forms.Form
	{
		
		StringFormat format;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ColorPenForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			MinimumSize = new Size(700,700);
			format = new StringFormat();
			format.Alignment = StringAlignment.Center;
			format.LineAlignment = StringAlignment.Center;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// ColorPenForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Name = "ColorPenForm";
			this.Text = "ColorPenForm";
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.ColorPenForm_Paint);

		}
		#endregion

		private void ColorPenForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			int count = 0;
			Graphics g = e.Graphics;
			String[] allNames = Enum.GetNames(typeof(System.Drawing.KnownColor));
			Rectangle rectBox = new Rectangle(0, 0, this.ClientRectangle.Width/6, 
				(this.ClientRectangle.Height - 30)/31);
			
			DrawCenterText(g, ref rectBox, "UI Colors");
			foreach (String colorName in allNames)
			{
				KnownColor known = (KnownColor) Enum.Parse(typeof(System.Drawing.KnownColor), colorName);
				Color colorCurrent = Color.FromKnownColor(known);
				using (Pen pen = new Pen(colorCurrent, 3)) 
				{
					pen.Alignment = PenAlignment.Inset;
					g.FillRectangle(GetBackBrush(colorCurrent), rectBox);
					g.DrawRectangle(pen, rectBox);
					g.DrawString(colorName, this.Font, GetTextBrush(colorCurrent), rectBox, format);
					rectBox.X += rectBox.Width;
					TestEndUIColors(g, ref rectBox, count);
					TestNewLine(ref rectBox);
				}
				count++;
			}				
		}

		public void DrawCenterText(Graphics g, ref Rectangle rect, String text) 
		{
			Rectangle rectWide = new Rectangle(rect.X, rect.Y, this.ClientRectangle.Width, rect.Height);
			g.DrawString(text, this.Font, GetBackBrush(this.BackColor), rectWide, this.format);
			StartNewLine(ref rect);
		}

		public void TestEndUIColors(Graphics g, ref Rectangle rect, int count) 
		{
			if (count == 26) 
			{
				StartNewLine(ref rect);
				DrawCenterText(g, ref rect, "Known Colors");
			}
		}

		public void TestNewLine(ref Rectangle rect) 
		{
			if (rect.X > this.ClientRectangle.Width - rect.Width) 
			{
				StartNewLine(ref rect);
			}		
		}

		public void StartNewLine(ref Rectangle rect) 
		{
			rect.X = 0;
			rect.Y += rect.Height;
		}

		public Brush GetTextBrush(Color color) 
		{
			if (color.GetBrightness() <= 0.4) 
			{
				return Brushes.Black;
			}
			return Brushes.White;
			
		}

		public Brush GetBackBrush(Color color) 
		{
			if (color.GetBrightness() > 0.4) 
			{
				return Brushes.Black;
			}
			return Brushes.White;
			
		}
	}
}
