using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Shapes 
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class ShapesForm : System.Windows.Forms.Form 
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		StringFormat format;

		public ShapesForm() 
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.SetStyle(ControlStyles.ResizeRedraw, true);
			this.SetStyle(ControlStyles.DoubleBuffer, true);
			this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);

		
			format = new StringFormat();
			format.Alignment = StringAlignment.Center;
			format.LineAlignment = StringAlignment.Center;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) 
		{
			if( disposing ) 
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() 
		{
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "Form1";
			this.Text = "Shapes";
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);

		}
		#endregion

		void Form1_Paint(object sender, PaintEventArgs e) 
		{
			Graphics g = e.Graphics;
			Rectangle rectBox = new Rectangle(0, 0, this.ClientRectangle.Width/3, this.ClientRectangle.Height/3);
			Brush fillBrush = Brushes.Gray;
			Pen whitePen = System.Drawing.Pens.White;

			using( Pen pen = new Pen(Color.Red, 4) ) 
			{
				// Arc
				g.DrawArc(pen, InflateRectCopy(rectBox, -10), 180, 180);
				DrawCenterText(g, ref rectBox, "Arc");

				// Bezier
				Point[] pointsDraw = InflateRectPoints(rectBox, -10);
				g.DrawBezier(pen, pointsDraw[0], pointsDraw[1], pointsDraw[2], pointsDraw[3]);
				DrawCenterText(g, ref rectBox, "Bezier");

				// Closed Curve
				g.FillClosedCurve(fillBrush, InflateRectPoints(rectBox, -10));
				DrawCenterText(g, ref rectBox, "Closed Curve");

				// Curve
				g.DrawCurve(pen, InflateRectPoints(rectBox, -10));
				DrawCenterText(g, ref rectBox, "Curve");


				// Ellipse
				Rectangle rectDraw = InflateRectCopy(rectBox, -10);
				g.FillEllipse(fillBrush, rectDraw);
				g.DrawEllipse(pen, rectDraw);
				DrawCenterText(g, ref rectBox, "Ellipse");


				// Lines
				g.DrawLines(pen, InflateRectPoints(rectBox, -10));
				DrawCenterText(g, ref rectBox, "Lines");


				// Pie
				rectDraw = InflateRectCopy(rectBox, -10);
				g.FillPie(fillBrush, rectDraw, 180, 180);
				g.DrawPie(pen, rectDraw, 180, 180);
				DrawCenterText(g, ref rectBox, "Arc");


				// Polygon
				pointsDraw = InflateRectPoints(rectBox, -10);
				g.FillPolygon(fillBrush, pointsDraw);
				g.DrawPolygon(pen, pointsDraw);
				DrawCenterText(g, ref rectBox, "Polygon");

				// Rectangle
				rectDraw = InflateRectCopy(rectBox, -10);
				g.FillRectangle(fillBrush, rectDraw);
				g.DrawRectangle(pen, rectDraw);
				DrawCenterText(g, ref rectBox, "Rectangle");
			}
		}

		public Rectangle InflateRectCopy(Rectangle rectBox, int inflate) 
		{
			Rectangle rectReturn = new Rectangle(rectBox.Location, rectBox.Size);
			rectReturn.Inflate(inflate, inflate);
			return rectReturn;
		}

		public Point[] InflateRectPoints(Rectangle rectBox, int inflate)
		{
			return new Point[] 
				{
					new Point(rectBox.Left  - inflate, rectBox.Bottom + inflate), 
					new Point(rectBox.Right + inflate, rectBox.Bottom + inflate), 
					new Point(rectBox.Left  - inflate, rectBox.Top    - inflate), 
					new Point(rectBox.Right + inflate, rectBox.Top    - inflate)
				};
		}

		public void DrawCenterText(Graphics g, ref Rectangle rect, String text) 
		{
			g.DrawString(text, this.Font, Brushes.Black, rect, format);
			rect.X = (rect.X > this.ClientRectangle.Width - 2*rect.Width ? 0 : rect.X + rect.Width);
			rect.Y = (rect.X == 0 ? rect.Y + rect.Height : rect.Y);
		}
      
	}
}
